// TestCaseGeneratorUI
// (c)2007 Mark Bulmahn. mBulmahn@web.de
// License: GPL 2.0
// Project: TestCaseGenerator. http://www.codeplex.com/TestCaseGenerator

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using TestCaseModel;

namespace TestCaseGenerator
{
    public partial class FrmMain : Form
    {
        public FrmMain()
        {
            InitializeComponent();
            InitAfterNew();
        }

        private void FrmMain_Load(object sender, EventArgs e)
        {
            //TestLoadModel();
            AutoLoadModel();
        }

        private void butLoad_Click(object sender, EventArgs e)
        {
            LoadModel();
        }

        private void butSaveModel_Click(object sender, EventArgs e)
        {
            SaveModel();
        }

        private void butCheckModel_Click(object sender, EventArgs e)
        {
            CheckModel();
        }

        private void butUndoGen_Click(object sender, EventArgs e)
        {
            UndoGen();
        }

        private void komplettNeuGenrierenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            GenTestCases(true);
        }

        private void generierenUndGgfErgebnissbernehmenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            GenTestCases(false);
        }

        private void ffnenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            LoadModel();
        }

        private void speichernToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveModel();
        }

        private void speichernUnterToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveModelAs();
        }

        private void beendenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            QuitApp();
        }

        private void neuToolStripMenuItem_Click(object sender, EventArgs e)
        {
            NewDoc();
        }

        private void berTestCaseGeneratorToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ShowAbout();
        }

        private void testflleKomplettNeuGenerierenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            GenTestCases(true);
        }

        private void testflleNeuGenerierenUndGgfErgebnissebernehmenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            GenTestCases(false);
        }

        private void modellPrfenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            CheckModel();
        }

        private void sQLServerToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ExportTestCases(TestCaseExporter.ExportType.MSSQL);
        }

        private void sQLCompactEditionToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ExportTestCases(TestCaseExporter.ExportType.SQLCE);
        }

        private void microsoftEXCELToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ExportTestCases(TestCaseExporter.ExportType.EXCEL);
        }

        private void cSVTextdateiToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ExportTestCases(TestCaseExporter.ExportType.CSV);
        }

        private void ergebnisregelnAnwendenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ApplyRules();
        }

        private void parameterClassesControl1_NbrOfParametersChanged(int nbrOfParameters)
        {
            NumberOfParametersChanged(nbrOfParameters);
        }

        private void einstellungenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ChangeSettings();
        }

        private void microsoftToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ChooseGenPict();
        }

        private void allgemeinerKombinationsgeneratorToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ChooseGenBuiltIn();
        }

        private void butSaveTcTable_Click(object sender, EventArgs e)
        {
            SaveTcTable();
        }

        private void butLoadTcTable_Click(object sender, EventArgs e)
        {
            //RefreshButLoadTcTable();
        }

        private void butExpHtml_Click(object sender, EventArgs e)
        {
            ExpTcTableAsHtml();
        }

        private void toolStripButton1_Click(object sender, EventArgs e)
        {

        }

        private void sQLServerToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            ExportTestCases(TestCaseExporter.ExportType.MSSQL);
        }

        private void sQLCEToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ExportTestCases(TestCaseExporter.ExportType.SQLCE);
        }

        private void excelToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ExportTestCases(TestCaseExporter.ExportType.EXCEL);
        }

        private void fillInExampleDataToolStripMenuItem_Click(object sender, EventArgs e)
        {
            FillInExampleData();
        }

        private void xMLToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ExportTestCases(TestCaseExporter.ExportType.XML);
        }

        private void registerFileTypeInWindowsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            DoRegisterFileType();
        }

        private void xMLWithHeaderToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ExportTestCases(TestCaseExporter.ExportType.XMLWithHeader);
        }

     }
}