﻿// TestCaseModel
// (c)2007 Mark Bulmahn. mBulmahn@web.de
// License: GPL 2.0
// Project: TestCaseGenerator. http://www.codeplex.com/TestCaseGenerator

using System;
using System.Collections.Generic;
using System.Text;

namespace TestCaseModel
{
    /// <summary>
    /// This is an interface for any test case generator in this project
    /// In fact it's rather simple: basically the only method that has to
    /// be implemented is "Calculate" ...
    /// </summary>
    interface ITcGenerator
    {
        int OrderOfCombination { get; set; }

        string[,] ParameterCombinations { get; }

        Parameters ModelParameters { set; }

        void Calculate();
    }
}
