// TestCaseModel
// (c)2007 Mark Bulmahn. mBulmahn@web.de
// License: GPL 2.0
// Project: TestCaseGenerator. http://www.codeplex.com/TestCaseGenerator

using System;
using System.Collections.Generic;
using System.Text;

namespace TestCaseModel
{
    /// <summary>
    /// A single result of some model checking routines
    /// </summary>
    [Serializable]
    public class ModelCheckResult
    {
        public enum ResultType { Nothing=0, ResultIsMissing = 1, ResultIsNeverUsedInModel = 2, Null = 99 }

        ResultType result = ResultType.Nothing;
        public ResultType Result
        {
            get { return result; }
            set { result = value; }
        }

        string comment = "";
        public string Comment
        {
            get { return comment; }
            set { comment = value; }
        }

        string objectDesc = "";
        public string ObjectDesc
        {
            get { return objectDesc; }
            set { objectDesc = value; }
        }

        public ModelCheckResult()
        {
        }

        public ModelCheckResult(ResultType result, string comment)
        {
            this.result = result;
            this.comment = comment;
        }
    }
}
