﻿// TestCaseModel
// (c)2007 Mark Bulmahn. mBulmahn@web.de
// License: GPL 2.0
// Project: TestCaseGenerator. http://www.codeplex.com/TestCaseGenerator

using System;
using System.Collections.Generic;
using System.Text;

namespace TestCaseModel
{
    /// <summary>
    /// This represents a so called "Equivalence class". In simple
    /// words: a simplified possible state of a parameter. E.g. theoretically
    /// a string for a "User Name" can have a lot of states. But in reality
    /// it can be simplified to "empty", "known", "unknown". So these would
    /// be the equvialence classes for a parameter "username".
    /// </summary>
    [Serializable]
    public class EquivClass
    {
        string id = "";

        public string Id
        {
            get { return id; }
            set { id = value; }
        }

        string description = "";

        public string Description
        {
            get { return description; }
            set { description = value; }
        }

        string exampleData = "";

        public string ExampleData
        {
            get { return exampleData; }
            set { exampleData = value; }
        }

        int orderId = 0;

        public int OrderId
        {
            get { return orderId; }
            set { orderId = value; }
        }

        public EquivClass(string id)
        {
            this.id = id;
        }

        public EquivClass()
        {
        }
    }
}
