// TestCaseModel
// (c)2007 Mark Bulmahn. mBulmahn@web.de
// License: GPL 2.0
// Project: TestCaseGenerator. http://www.codeplex.com/TestCaseGenerator

using System;
using System.Collections.Generic;
using System.Text;

namespace TestCaseModel
{
    /// <summary>
    /// Represents an expected test result - for now just a simple description
    /// </summary>
    [Serializable]
    public class ExpectedResult
    {
        public enum ResultType
        {
            General = 0,
            NegativeResult = 1,
            ErrorMessage = 2
        }

        string id = "";
        public string Id
        {
            get { return id; }
            set { id = value; }
        }

        string desc = "";
        public string Desc
        {
            get { return desc; }
            set { desc = value; }
        }

        ResultType resType = ResultType.General;
        public ResultType ResType
        {
            get { return resType; }
            set { resType = value; }
        }

        public string ResTypeText
        {
            get
            {
                return GetResultTypeText(this.resType);
            }
        }

               
        public ExpectedResult()
        {
        }

        public ExpectedResult(string id)
        {
            this.id = id;
        }

        public static string GetResultTypeText(ResultType r)
        {
            
            switch (r)
            {
                case ResultType.General:
                    return "Allgemein";
                case ResultType.ErrorMessage:
                    return "Fehlermeldung";
                case ResultType.NegativeResult:
                    return "Negativergebnis";
            }
            return null;
        }
    }
}
